<?php

header('Content-Type: application/json; charset=utf-8');

#error_reporting(E_ALL);
#ini_set("display_errors", 1);

define('MEDIA_URL', 'media/');
define('MEDIA_PATH', dirname($_SERVER['SCRIPT_FILENAME']) . '/' . MEDIA_URL);
define('MEDIA_REQUEST_VERSION', 1.0);

define('UPLOAD_USER', 'ringo');
// SHA-1 password hash
define('UPLOAD_PASSWORD', '3f011cebe6601cb057d955309be97c1e3d77db2f'); // ringo

define('ERROR_UNKNOWN', 'unknown');
define('ERROR_UNKNOWN_PROTOCOL_VERSION', 'unknownProtocolVersion');
define('ERROR_UNKNOWN_REQUEST_TYPE', 'unknownRequestType');
define('ERROR_AUTHENTICATION_REQUIRED', 'authenticationRequired');
define('ERROR_AUTHENTICATION_FAILED', 'authenticationFailed');

$response = array();

if (isset($_POST['mediaRequest'])) {

  if ($_POST['mediaRequest']['version'] == MEDIA_REQUEST_VERSION) {

    $response = array(
      'version' => MEDIA_REQUEST_VERSION,
      'type' => $_POST['mediaRequest']['type']
    );
    
    if (isset($_POST['mediaRequest']['id'])) {
    
      $response['requestId'] = $_POST['mediaRequest']['id'];
    }
  
    switch ($_POST['mediaRequest']['type']) {
    
      case 'info':
      
        $response['result'] = 'success';
        $response['info'] = array(
          'title' => 'Ringo',
          'allowed' => array('list', 'add'),
          'restricted' => array('add'),
        );
        break;
        
      case 'list':

        $response['result'] = 'success';
        $response['resources'] = array(
          MEDIA_URL . 'image/red-apple.jpg' => array(
            'title' => 'Roter Apfel',
            'type' => 'image/jpeg',
            'size' => 94538,
            'thumbnail' => MEDIA_URL . 'image/red-apple-thumb.jpg',
            'rating' => 0.8, # Test: resource with rating
          ),
          MEDIA_URL . 'image/grass-ripples.jpg' => array(
            'title' => 'Gras mit Wellen',
            'type' => 'image/jpeg',
            'size' => 175426,
            'thumbnail' => MEDIA_URL . 'image/grass-ripples-thumb.jpg',
          ),
          MEDIA_URL . 'image/cherry-blossoms.jpg'=> array(
            'title' => 'Kirschblüten',
            'type' => 'image/jpeg',
            'size' => 1150435,
            'thumbnail' => MEDIA_URL . 'image/cherry-blossoms-thumb.jpg',
            'rating' => 0.256979, # Test: resource with odd rating
          ),
          MEDIA_URL . 'image/woods.jpg' => array(
            'title' => 'Wälder',
            'type' => 'image/jpeg',
            'size' => 226807,
            'thumbnail' => MEDIA_URL . 'image/woods-thumb.jpg'
          ),
          MEDIA_URL . 'audio/seagulls.mp3' => array(
            #'title' => 'Möven', # Test: resource without title
            'type' => 'audio/mpeg',
            'size' => 40986
          ),
          MEDIA_URL . 'audio/seagulls.ogg' => array(
            'title' => 'Möven',
            'type' => 'audio/ogg',
            'size' => 21236
          ),
          MEDIA_URL . 'video/big-buck-bunny-trailer-480p.ogg' => array(
            'title' => 'Big Buck Bunny Trailer',
            'type' => 'video/ogg',
            'size' => 4360399,
            'thumbnail' => MEDIA_URL . 'video/big-buck-bunny-trailer-thumb.jpg'
          ),
          MEDIA_URL . 'video/big-buck-bunny-trailer-iphone.m4v' => array(
            'title' => 'Big Buck Bunny iPhone Trailer',
            'type' => 'video/mp4',
            #'size' => 3889885, # Test: resource without size
            'thumbnail' => MEDIA_URL . 'video/big-buck-bunny-trailer-thumb.jpg'
          ),
          MEDIA_URL . 'text/nichts.txt' => array(
            'title' => 'Nichts',
            'type' => 'text/plain',
            'size' => 2643
          )
        );
        break;
        
      case 'add':
      
        if (isset($_POST['mediaRequest']['resources']) || isset($_FILES['mediaRequest'])) {
        
          $credentials = array();
        
          if (isset($_POST['mediaRequest']['credentials'])) {
          
            $credentials = json_decode($_POST['mediaRequest']['credentials'], true);
          }

          if (!isset($credentials['username']) || !isset($credentials['password'])) {
            
            $response['result'] = 'error';
            $response['error'] = array(
              'code' => ERROR_AUTHENTICATION_REQUIRED,
              'message' => 'Authentication required.'
            );
          } elseif ($credentials['username'] != UPLOAD_USER ||
                    $credentials['password'] != UPLOAD_PASSWORD) {
          
            $response['result'] = 'error';
            $response['error'] = array(
              'code' => ERROR_AUTHENTICATION_FAILED,
              'message' => 'Authentication failed.'
            );
          } else {
          
            $succeeded = array();
            $failed = array();
          
            if (isset($_POST['mediaRequest']['resources'])) {
            
              $resources = json_decode($_POST['mediaRequest']['resources'], true);
            
              foreach ($resources as $url => $properties) {
                
                $request = curl_init($url);
                $tempfile = tmpfile(); // May return FALSE
                curl_setopt($request, CURLOPT_HEADER, false);
                curl_setopt($request, CURLOPT_FILE, $tempfile);
                
                if (isset($properties['__credentials__'])) {
                
                  $credentials = json_decode($properties['__credentials__']);
                  curl_setopt($request, CURLOPT_USERPWD,
                    sprintf('%s:%s', $credentials['username'], $credentials['password']));
                  unset($properties['__credentials__']);
                }
                
                $success = curl_exec($request);
                $http_code = curl_getinfo($request, CURLINFO_HTTP_CODE);
                curl_close($request);
                
                if (!$success || $http_code == 404) {
                
                  fclose($tempfile);
                  
                  // XXX: Maybe also store reason
                  $failed[$url] = $properties;
                  continue;
                }
                
                fflush($tempfile); // Ensure complete write
                
                if (!isset($properties['type'])) {
                
                  // TODO: Copy to known file path, use mime_content_type()
                }
                  
                /*
                // Override for specific OGG types
                if ($properties['type'] == 'application/ogg') {
            
                  $filedata = exec('file ' . $temppath);
                  
                  if (stripos($filedata, 'audio')) {
                  
                    $properties['type'] = 'audio/ogg';
                  } elseif (stripos($filedata, 'video')) {
                  
                    $properties['type'] = 'video/ogg';
                  }
                }
                */
        
                // Prepare data paths
                $general_type = explode('/', $properties['type']);
                $general_type = $general_type[0];
                $filename = explode('/', $url);
                $filename = $filename[count($filename) - 1];
                $path = sprintf('%s%s/%s', MEDIA_PATH, $general_type, $filename);
                $url = sprintf('%s%s/%s', MEDIA_URL, $general_type, $filename);
                
                if (!file_exists(MEDIA_PATH . $general_type)) {
                
                  mkdir(MEDIA_PATH . $general_type);
                }
        
                // Store resource at its final location
                $targetfile = fopen($path, 'w');
                fseek($tempfile, 0, SEEK_SET);
                stream_copy_to_stream($tempfile, $targetfile);
                fclose($targetfile);
                fclose($tempfile);
    
                // Prepare thumbnail paths
                list ($name, $extension) = explode('.', $filename, 2);
                $thumbnail_path = sprintf('%s%s/%s-thumb.%s', MEDIA_PATH, $general_type, $name, $extension);
                $thumbnail_url = sprintf('%s%s/%s-thumb.%s', MEDIA_URL, $general_type, $name, $extension);
                
                if (isset($properties['thumbnail'])) { // Try to retrieve existing thumbnail
                
                  $tempfile = tmpfile();
                  $request = curl_init($properties['thumbnail']);
                  curl_setopt($request, CURLOPT_HEADER, false);
                  curl_setopt($request, CURLOPT_FILE, $tempfile);
                  
                  // Remove reference to existing thumbnail in any case
                  unset($properties['thumbnail']);
                  
                  $success = curl_exec($request);
                  $http_code = curl_getinfo($request, CURLINFO_HTTP_CODE);
                  curl_close($request);
                
                  if ($success && ($http_code != 404)) {
                  
                    fflush($tempfile); // Ensure complete write
                    // Copy thumbnail data to its final location
                    $targetfile = fopen($thumbnail_path, 'w');
                    stream_copy_to_stream($tempfile, $targetfile);
                    fclose($targetfile);
                    
                    // Store the new thumbnail location
                    $properties['thumbnail'] = $thumbnail_url;
                  }
                  
                  fclose($tempfile);
                } else { // Create new thumbnail if possible
                
                  switch ($general_type) {
                  
                    case 'image': // Use ImageMagick for images
                    
                      // Resize to maximum width and crop to fixed size
                      system('/usr/bin/convert' .
                               ' -extent 200x200' .
                               ' -resize 200x' .
                               ' -resize "x200<"' .
                               ' -gravity center' .
                               ' -crop 200x200+0+0' .
                               ' -quality 90 ' .
                               $path . ' ' .
                               $thumbnail_path,
                             $return_value);
                        
                        
                      if ($return_value == 0) {
                      
                        // Store the new thumbnail location
                        $properties['thumbnail'] = $thumbnail_url;
                      }
                      break;
                  }
                }
                
                // Store resource in the list of successfully processed resources
                $succeeded[$url] = $properties;
              }
            }
            
            if (isset($_FILES['mediaRequest']) || isset($_POST['mediaRequest']['files'])) {
            
              if (isset($_POST['mediaRequest']['files'])) {
              
                $_FILES['mediaRequest']['files'] = json_decode($_POST['mediaRequest']['files'], true);
                
                for ($i = 0; $i < count($_FILES['mediaRequest']['files']); ++$i) {
                
                  $_FILES['mediaRequest']['files'][$i]['tmp_name'] = tempnam(sys_get_temp_dir(), 'php');
                  
                  file_put_contents(
                    $_FILES['mediaRequest']['files'][$i]['tmp_name'],
                    base64_decode($_FILES['mediaRequest']['files'][$i]['data'])
                  );
                }
              } else {
              
                require_once('fixfilesarray.php');
              
                $_FILES['mediaRequest'] = fixFilesArray($_FILES['mediaRequest']);
              }
            
              // Handle files
              foreach ($_FILES['mediaRequest']['files'] as $file) {
        
                // Prepare data paths
                $general_type = explode('/', $file['type']); // May not be set
                $general_type = $general_type[0];
                $url = sprintf('%s%s/%s', MEDIA_URL, $general_type, $file['name']);
                $path = sprintf('%s%s/%s', MEDIA_PATH, $general_type, $file['name']);
                $properties = array(
                  'size' => $file['size'],
                  'type' => $file['type']
                );
                
                if (!file_exists(MEDIA_PATH . $general_type)) {
                
                  mkdir(MEDIA_PATH . $general_type);
                }
                
                // Store resource at its final location
                if (isset($_POST['mediaRequest']['files'])) {
                
                  $success = rename($file['tmp_name'], $path);
                } else {
                  $success = move_uploaded_file($file['tmp_name'], $path);
                }
    
                // Prepare thumbnail paths
                list ($name, $extension) = explode('.', $file['name'], 2);
                $thumbnail_path = sprintf('%s%s/%s-thumb.%s', MEDIA_PATH, $general_type, $name, $extension);
                $thumbnail_url = sprintf('%s%s/%s-thumb.%s', MEDIA_URL, $general_type, $name, $extension);
                
                // Create new thumbnail if possible
                switch ($general_type) {
                
                  case 'image': // Use ImageMagick for images
                  
                    // Resize to maximum width and crop to fixed size
                    system('/usr/bin/convert' .
                             ' -extent 200x200' .
                             ' -resize 200x' .
                             ' -resize "x200<"' .
                             ' -gravity center' .
                             ' -crop 200x200+0+0' .
                             ' -quality 90 ' .
                             $path . ' ' .
                             $thumbnail_path,
                           $return_value);
                      
                      
                    if ($return_value == 0) {
                    
                      // Store the new thumbnail location
                      $properties['thumbnail'] = $thumbnail_url;
                    }
                    break;
                }
                
                if ($success) {
                
                  $succeeded[$url] = $properties;
                } else {
                
                  $failed[$url] = $properties;
                }
              }
            }
            
            /*if (count($failed) > 0) {
            
              $response['result'] = 'error';
              $response['error'] = 'Failed to process some resources.';
            } else*/if (count($succeeded) > 0) {
            
              $response['result'] = 'success';
              $response['resources'] = $succeeded;
            } else {
            
              $response['result'] = 'error';
              $response['error'] = array(
                'code' => ERROR_UNKNOWN,
                'message' => 'Nothing processed.'
              );
            }
          }
        } else {
             
          $response['result'] = 'error';
          $response['error'] = array(
            'code' => ERROR_UNKNOWN,
            'message' => 'No resource to add.'
          );
        }
        break;
        
      case 'remove':
        break;
        
      default:
        
        $response['result'] = 'error';
        $response['error'] = array(
          'code' => ERROR_UNKNOWN_REQUEST_TYPE,
          'message' => 'Unknown request type.'
        );
        break;
    }
  } else {
  
    $response['result'] = 'error';
    $response['error'] = array(
      'code' => ERROR_UNKNOWN_PROTOCOL_VERSION,
      'message' => 'Unknown protocol version.'
    );
  }
}

echo json_encode($response);

?>
